// pdnmeshDoc.h : interface of the CPdnmeshDoc class
//
/*  pdnmesh - a 2D finite element solver
    Copyright (C) 2001-2005 Sarod Yatawatta <sarod@users.sf.net>  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  $Id: pdnmeshDoc.h,v 1.8 2005/02/16 13:16:15 sarod Exp $
*/
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_PDNMESHDOC_H__E30443B2_CABB_4CFB_BC44_86EF7EBC7A13__INCLUDED_)
#define AFX_PDNMESHDOC_H__E30443B2_CABB_4CFB_BC44_86EF7EBC7A13__INCLUDED_

#include "model.h"
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CPdnmeshDoc : public CDocument
{
protected: // create from serialization only
	CPdnmeshDoc();
	DECLARE_DYNCREATE(CPdnmeshDoc)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPdnmeshDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CPdnmeshDoc();
	void	draw(void);
	void AddToRecentFileList(LPCTSTR lpszPathName);
	Model *model;
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CPdnmeshDoc)
	afx_msg void OnFileSaveAs();
	afx_msg void OnSolveOptions();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PDNMESHDOC_H__E30443B2_CABB_4CFB_BC44_86EF7EBC7A13__INCLUDED_)
