// pdnmeshView.h : interface of the CPdnmeshView class
//
/*  pdnmesh - a 2D finite element solver
    Copyright (C) 2001-2005 Sarod Yatawatta <sarod@users.sf.net>  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  $Id: pdnmeshView.h,v 1.5 2005/02/16 13:16:15 sarod Exp $
*/
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_PDNMESHVIEW_H__4B23229B_67E8_446E_9A6A_9F4AD6C2C2DA__INCLUDED_)
#define AFX_PDNMESHVIEW_H__4B23229B_67E8_446E_9A6A_9F4AD6C2C2DA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//OpenGL headers
#include <gl/gl.h>
#include <gl/glu.h>
#include <math.h>

class CPdnmeshView : public CView
{
protected: // create from serialization only
	CPdnmeshView();
	DECLARE_DYNCREATE(CPdnmeshView)

// Attributes
public:
	CPdnmeshDoc* GetDocument();
  
  HDC m_hgldc; //device context
	HGLRC m_hglrc; //rendering context
 
  //GL utility functions
  BOOL SetPixelformat(HDC hdc);
	void ReSizeGLScene(int width, int height);
	void GetGLInfo();
  int DrawGLScene(void);
	int InitGL(void);

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPdnmeshView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CPdnmeshView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CPdnmeshView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnDrawCfill();
	afx_msg void OnDrawContour();
	afx_msg void OnDrawGrad();
	afx_msg void OnDrawMesh();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnZoomAll();
	afx_msg void OnZoomBack();
	afx_msg void OnZoomStart();
	afx_msg void OnNextEigenmode();
	afx_msg void OnSolve();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in pdnmeshView.cpp
inline CPdnmeshDoc* CPdnmeshView::GetDocument()
   { return (CPdnmeshDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PDNMESHVIEW_H__4B23229B_67E8_446E_9A6A_9F4AD6C2C2DA__INCLUDED_)
